--
-- heder_senator
-- Specjalizacja hedera do kombajnu bizon
-- Script na podstawie dostepnych scriptow
--
-- @author  badziu
-- @date  22/12/10
--
-- Copyright (C) badziu, All Rights Reserved.


bizek = {};

function bizek.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cutter, specializations);
end;

function bizek:load(xmlFile)
	---------------------------Motowidla gora/dol--------------------------------------------------
		local widelkiNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.widelki#index"));
		if widelkiNode ~= nil then
        self.widelki = {};
        self.widelki.node = widelkiNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.widelki#minRot"));
        self.widelki.minRot = {};
        self.widelki.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.widelki.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.widelki.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.widelki#maxRot"));
        self.widelki.maxRot = {};
        self.widelki.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.widelki.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.widelki.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.widelki.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.widelki#rotTime"), 2)*1000;
        self.widelki.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.widelki#touchRotLimit"), 10));
    end;
    
       self.motowidla2Speed = 0.0012;
	  self.naginacz = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.naginacz#index"));
   self.naginacz2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.naginacz2#index"));
    self.naginacz3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.naginacz3#index"));
     self.naginacz4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.naginacz4#index"));
   self.naginaczActive = false;
   self.naginacz2Active = true;
    self.naginacz3Active = false;
     self.naginacz4Active = true;
------------------------------Dzioby------------------------------------------------------------
	self.lokalizacja_dzioba = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lokalizacja_dzioba#index"));
	self.lokalizacja_dzioba2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lokalizacja_dzioba2#index"));
	
	self.numdzibys = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dziby#count"), 0);
    self.dzibys = {};
    for i=1, self.numdzibys do
        local dzibynamei = string.format("vehicle.dziby.dziby" .. "%d", i);
        self.dzibys[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, dzibynamei .. "#index"));
        setVisibility(self.dzibys[i], true);
    end;
    
    self.numdzibys2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dziby2#count"), 0);
    self.dzibys2 = {};
    for i=1, self.numdzibys2 do
        local dziby2namei = string.format("vehicle.dziby2.dziby2" .. "%d", i);
        self.dzibys2[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, dziby2namei .. "#index"));
        setVisibility(self.dzibys2[i], true);
    end;
    
  self.numdzibys3 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dziby3#count"), 0);
    self.dzibys3 = {};
    for i=1, self.numdzibys3 do
        local dziby3namei = string.format("vehicle.dziby3.dziby3" .. "%d", i);
        self.dzibys3[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, dziby3namei .. "#index"));
        setVisibility(self.dzibys3[i], true);
    end;
	    
      self.numdzibys4 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dziby4#count"), 0);
    self.dzibys4 = {};
    for i=1, self.numdzibys4 do
        local dziby4namei = string.format("vehicle.dziby4.dziby4" .. "%d", i);
        self.dzibys4[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, dziby4namei .. "#index"));
        setVisibility(self.dzibys4[i], true);
    end;
    
    
    
      self.numdzibys5 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dziby5#count"), 0);
    self.dzibys5 = {};
    for i=1, self.numdzibys5 do
        local dziby5namei = string.format("vehicle.dziby5.dziby5" .. "%d", i);
        self.dzibys5[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, dziby5namei .. "#index"));
        setVisibility(self.dzibys5[i], true);
    end;
    
	self.dzibyvis = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kosa_vis#index"));
	self.dzibyvisActive = false;
	self.dzibysActive = false;
		self.dzibyvis2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kosa2_vis#index"));
	self.dzibyvis2Active = true;
	self.dzibys2Active = true;
		self.dzibyvis3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kosa3_vis#index"));
	self.dzibyvis3Active = true;
	self.dzibys3Active = true;
		self.dzibyvis4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kosa4_vis#index"));
	self.dzibyvis4Active = true;
	self.dzibys4Active = true;
		self.dzibyvis5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kosa5_vis#index"));
	self.dzibyvis5Active = true;
	self.dzibys5ctive = true;
-------------------------------------------------------------------------------------	
	self.szajba1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba1#index"));
	self.szajba2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba2#index"));
	self.szajba3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba3#index"));
	self.szajba4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba4#index"));
	self.szajba5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba5#index"));
	self.szajba6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba6#index"));
		self.szajba7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba7#index"));
			self.szajba8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba8#index"));
				self.szajba9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba9#index"));
					self.szajba10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba10#index"));
						self.szajba11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba11#index"));
							self.szajba12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba12#index"));
								self.szajba13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba13#index"));
									self.szajba14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba14#index"));
										self.szajba15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba15#index"));
											self.szajba16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba16#index"));
											self.szajba17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.szajba17#index"));
	
	
	
	
	
	local kosaindex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kosa#index"));
    	if kosaindex ~= nil then
        self.kosa = {};
        self.kosa.node = kosaindex;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa#minTrans"));
        self.kosa.minTrans = {};
        self.kosa.minTrans[1] = Utils.getNoNil(x, 0);
        self.kosa.minTrans[2] = Utils.getNoNil(y, 0);
        self.kosa.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa#maxTrans"));
        self.kosa.maxTrans = {};
        self.kosa.maxTrans[1] = Utils.getNoNil(x, 0);
        self.kosa.maxTrans[2] = Utils.getNoNil(y, 0);
        self.kosa.maxTrans[3] = Utils.getNoNil(z, 0);

        self.kosa.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa#transTime"), 2)*1000;
        self.kosa.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa#touchTransLimit"), 10);
    end;
		self.predkosc = 80


       	local kosa2index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kosa2#index"));
    	if kosa2index ~= nil then
        self.kosa2 = {};
        self.kosa2.node = kosa2index;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa2#minTrans"));
        self.kosa2.minTrans = {};
        self.kosa2.minTrans[1] = Utils.getNoNil(x, 0);
        self.kosa2.minTrans[2] = Utils.getNoNil(y, 0);
        self.kosa2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa2#maxTrans"));
        self.kosa2.maxTrans = {};
        self.kosa2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.kosa2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.kosa2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.kosa2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa2#transTime"), 2)*1000;
        self.kosa2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa2#touchTransLimit"), 10);
    end;
		self.predkosc = 80
		
		
	  	local kosa3index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kosa3#index"));
    	if kosa3index ~= nil then
        self.kosa3 = {};
        self.kosa3.node = kosa3index;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa3#minTrans"));
        self.kosa3.minTrans = {};
        self.kosa3.minTrans[1] = Utils.getNoNil(x, 0);
        self.kosa3.minTrans[2] = Utils.getNoNil(y, 0);
        self.kosa3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa3#maxTrans"));
        self.kosa3.maxTrans = {};
        self.kosa3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.kosa3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.kosa3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.kosa3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa3#transTime"), 2)*1000;
        self.kosa3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa3#touchTransLimit"), 10);
    end;
		self.predkosc = 80
		
		
		  	local kosa4index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kosa4#index"));
    	if kosa4index ~= nil then
        self.kosa4 = {};
        self.kosa4.node = kosa4index;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa4#minTrans"));
        self.kosa4.minTrans = {};
        self.kosa4.minTrans[1] = Utils.getNoNil(x, 0);
        self.kosa4.minTrans[2] = Utils.getNoNil(y, 0);
        self.kosa4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa4#maxTrans"));
        self.kosa4.maxTrans = {};
        self.kosa4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.kosa4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.kosa4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.kosa4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa4#transTime"), 2)*1000;
        self.kosa4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa4#touchTransLimit"), 10);
    end;
		self.predkosc = 80
		
		
		  	local kosa5index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kosa5#index"));
    	if kosa5index ~= nil then
        self.kosa5 = {};
        self.kosa5.node = kosa5index;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa5#minTrans"));
        self.kosa5.minTrans = {};
        self.kosa5.minTrans[1] = Utils.getNoNil(x, 0);
        self.kosa5.minTrans[2] = Utils.getNoNil(y, 0);
        self.kosa5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kosa5#maxTrans"));
        self.kosa5.maxTrans = {};
        self.kosa5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.kosa5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.kosa5.maxTrans[3] = Utils.getNoNil(z, 0);

        self.kosa5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa5#transTime"), 2)*1000;
        self.kosa5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kosa5#touchTransLimit"), 10);
    end;
		self.predkosc = 80

			
             
		
		    self.motowidlaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.motowidla#index"));
			self.slimakNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.slimak#index"));
			local indexDrucikiStr = getXMLString(xmlFile, "vehicle.druciki#index");
				self.drucikiCount = getXMLInt(xmlFile, "vehicle.druciki#count");
				self.drucikiRootNode = Utils.indexToObject(self.components, indexDrucikiStr);
		
end;

function bizek:delete()
end;

function bizek:mouseEvent(posX, posY, isDown, isUp, button)
end;

function bizek:keyEvent(unicode, sym, modifier, isDown)


-------------------------Motowidla gora/dol------------------------------
	if sym == Input.KEY_KP_8 then
		self.widelkiMax = isDown;	
	end;
	if sym == Input.KEY_KP_2 then
		self.widelkiMin = isDown;		
	end;
		if isDown and sym == Input.KEY_KP_5 then
			self.dzibysActive = not self.dzibysActive;
			self.dzibyvisActive = not self.dzibyvisActive;
			self.dzibys2Active = not self.dzibys2Active;
			self.dziby2visActive = not self.dziby2visActive;
	end;
	
	
	 if sym == Input.KEY_KP_1 then 
		self.wolniej = isDown;
	end;
	if sym == Input.KEY_KP_3 then
		self.szybciej = isDown;
	end;
	
	
	if isDown and sym == Input.KEY_l then
 self.naginaczActive = not self.naginaczActive;
 self.naginacz2Active = not self.naginacz2Active;
end;
	if isDown and sym == Input.KEY_j then
 self.naginacz3Active = not self.naginacz3Active;

end;

	if isDown and sym == Input.KEY_KP_1 then
 self.naginacz4Active = not self.naginacz4Active;

end;


	
end;

function bizek:update(dt)
	----------------Motowidla gora/dol-----------------------------------------------
local doRotate = self.widelkiMax or self.widelkiMin 
	if self.widelki ~= nil and doRotate then
        	local x, y, z = getRotation(self.widelki.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.widelki.maxRot, self.widelki.minRot, 3, self.widelki.rotTime, dt, not self.widelkiMax);
        	setRotation(self.widelki.node, unpack(newRot));
	end;  
	
     if self.szybciej then		
	if self.motowidla2Speed < 0.005 then
			self.motowidla2Speed = self.motowidla2Speed + 0.00009;
		end;	
end;
if self.wolniej then
	if self.motowidla2Speed > 0.0015 then
			self.motowidla2Speed = self.motowidla2Speed - 0.00009;
	end;
end;



	   setVisibility(self.naginacz, self.naginaczActive);
       setVisibility(self.naginacz2, self.naginacz2Active);
	   setVisibility(self.naginacz3, self.naginacz3Active);
	    setVisibility(self.naginacz4, self.naginacz4Active);
	
---------------Motowidla przod/tyl-----------------------------------------------
local doTranslate = self.translationMax or self.translationMin
		if self.translationPart ~= nil and doTranslate then
			local x, y, z = getTranslation(self.translationPart.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
			setTranslation(self.translationPart.node, unpack(newTrans));
		end;
		
-------------------------Dzioby-------------------------------------------------	
       if self.dzibysActive then
		   for i=1, self.numdzibys do
			local dziby = self.dzibys[i];
			setVisibility(dziby, self.wdzibysActive);
		   end;
	       else
		   for i=1, self.numdzibys do
			local dziby = self.dzibys[i];
			setVisibility(dziby, self.dzibysActive, false);
		   end;
	    end;
		setVisibility(self.dzibyvis, self.dzibyvisActive);
		setVisibility(self.dziby2vis, self.dziby2visActive);
			setVisibility(self.dziby3vis, self.dziby3visActive);
				setVisibility(self.dziby4vis, self.dziby4visActive);
					setVisibility(self.dziby5vis, self.dziby5visActive);
		
 	if self.reelStarted then
		rotate(self.szajba1,dt*-15, 0,0);
		rotate(self.szajba2,dt*-15, 0,0);
		rotate(self.szajba3,dt*-15, 0,0);
		rotate(self.szajba4,dt*-15, 0,0);
		rotate(self.szajba5,dt*-15, 0,0);
		rotate(self.szajba6,dt*-15, 0,0);
		rotate(self.szajba7,dt*-15, 0,0);
		rotate(self.szajba8,dt*-15, 0,0);
		rotate(self.szajba9,dt*-15, 0,0);
		rotate(self.szajba10,dt*-15, 0,0);
		rotate(self.szajba11,dt*-15, 0,0);
		rotate(self.szajba12,dt*-15, 0,0);
		rotate(self.szajba13,dt*-15, 0,0);
		rotate(self.szajba14,dt*-15, 0,0);
		rotate(self.szajba15,dt*-15, 0,0);
		rotate(self.szajba16,dt*-15, 0,0);
			rotate(self.szajba17,dt*-15, 0,0);
	end;
	
	if self.reelStarted then
		self.predkosc = self.predkosc - dt;
		if self.predkosc < 0 then
			self.kosaMax = not self.kosaMax;
			self.kosa2Max = not self.kosa2Max;
			self.kosa3Max = not self.kosa3Max;
			self.kosa4Max = not self.kosa4Max;
			self.kosa5Max = not self.kosa5Max;
			self.predkosc = 80;
		end;

	end;
	if self.kosaMax ~= nil then
	local x, y, z = getTranslation(self.kosa.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.kosa.maxTrans, self.kosa.minTrans, 3, self.kosa.transTime, dt, not self.kosaMax);
        setTranslation(self.kosa.node, unpack(newTrans));
	end;
	
		if self.kosa2Max ~= nil then
	local x, y, z = getTranslation(self.kosa2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.kosa2.maxTrans, self.kosa2.minTrans, 3, self.kosa2.transTime, dt, not self.kosa2Max);
        setTranslation(self.kosa2.node, unpack(newTrans));
	end;
	
		if self.kosa3Max ~= nil then
	local x, y, z = getTranslation(self.kosa3.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.kosa3.maxTrans, self.kosa3.minTrans, 3, self.kosa3.transTime, dt, not self.kosa3Max);
        setTranslation(self.kosa3.node, unpack(newTrans));
	end;
	
		if self.kosa4Max ~= nil then
	local x, y, z = getTranslation(self.kosa4.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.kosa4.maxTrans, self.kosa4.minTrans, 3, self.kosa4.transTime, dt, not self.kosa4Max);
        setTranslation(self.kosa4.node, unpack(newTrans));
	end;
	  	if self.kosa5Max ~= nil then
	local x, y, z = getTranslation(self.kosa5.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.kosa5.maxTrans, self.kosa5.minTrans, 3, self.kosa5.transTime, dt, not self.kosa5Max);
        setTranslation(self.kosa5.node, unpack(newTrans));
	end;
	
	
	 if self.reelStarted then
        rotate(self.slimakNode, dt*self.reelSpeed*3, 0, 0);


    end;
     if self.reelStarted then
        rotate(self.slimakNode, dt*self.reelSpeed*3, 0, 0);
        if self.motowidlaNode ~= nil then
            rotate(self.motowidlaNode, dt*self.motowidla2Speed, 0, 0);
            atx, aty, atz = getRotation(self.motowidlaNode);
            for i=1, self.drucikiCount do
                local drucik    =    getChildAt(self.drucikiRootNode, i-1);
                tx, ty, tz = getRotation(drucik);
                setRotation(drucik, -atx, aty, atz);
            end;
        end;
    end;


end;

function bizek:draw()
end;

